import { promises as fs, existsSync } from "fs"
import { webcrypto } from "crypto"

import type { IAdapter } from "./index"

/**
 * Default Node.js adapter. This can be used while using `opvault.js`
 * in a Node.js environment.
 */
export const nodeAdapter: IAdapter = {
  fs: {
    readFile: path => fs.readFile(path, "utf-8"),
    readBuffer: path => fs.readFile(path),
    writeFile: fs.writeFile,
    readdir: fs.readdir,
    isDirectory: async path => fs.stat(path).then(x => x.isDirectory()),
    exists: async path => existsSync(path),
  },
  subtle: (webcrypto as any).subtle,
}
