import json from "./res.json"

const [locale] = Intl.DateTimeFormat().resolvedOptions().locale.split("-")

const mapValue = <T, R>(
  object: Record<string, T>,
  fn: (value: T, key: string) => R
): Record<string, R> => {
  const res = Object.create(null)
  Object.entries(object).forEach(([key, value]) => {
    res[key] = fn(value, key)
  })
  return res
}

type json = typeof json
export type i18n = {
  [K in keyof json]: {
    [L in keyof json[K]]: string
  }
}

export const i18n: i18n = mapValue(json, dict =>
  mapValue(dict, (value: any) => value[locale] ?? value.en)
) as any
