#!/usr/bin/env node
// @ts-check
const { builtinModules } = require("module")
const { build } = require("esbuild")

const args = process.argv.slice(2)

build({
  bundle: true,
  define: {},
  entryPoints: [
    "./src/electron/index.ts",
    // "./src/electron/preload.ts"
  ],
  outdir: "./dist/main",
  external: builtinModules.concat("electron"),
  target: ["chrome90"],
  tsconfig: "./tsconfig.json",
  sourcemap: "external",
  minify: process.env.NODE_ENV === "production",
  banner: {
    js: "/* eslint-disable */",
  },
  loader: {
    ".png": "file",
    ".eot": "file",
    ".svg": "file",
    ".woff": "file",
    ".woff2": "file",
    ".ttf": "file",
  },
  watch: args.includes("-w") || args.includes("--watch"),
})
