import styled from "@emotion/styled"
import type { ItemField, ItemSection } from "opvault.js"
import { ErrorBoundary } from "./ErrorBoundary"
import { ItemFieldValue, ItemDetailsFieldValue } from "./ItemFieldValue"

export { Container as FieldContainer }
const Container: React.FC = styled.div`
  padding: 5px 0;
  margin-bottom: 3px;
`
export const FieldTitle: React.FC = styled.div`
  font-size: 85%;
  margin-bottom: 3px;
`

export const ItemFieldView: React.FC<{
  field: ItemSection.Any
}> = ({ field }) => {
  if (field.v == null) {
    return null
  }

  return (
    <ErrorBoundary>
      <Container>
        <FieldTitle>{field.t}</FieldTitle>
        <ItemFieldValue field={field} />
      </Container>
    </ErrorBoundary>
  )
}

export const ItemDetailsFieldView: React.FC<{
  field: ItemField
}> = ({ field }) => {
  if (field.value == null) {
    return null
  }

  return (
    <ErrorBoundary>
      <Container>
        <FieldTitle>{field.name}</FieldTitle>
        <ItemDetailsFieldValue field={field} />
      </Container>
    </ErrorBoundary>
  )
}
